/*--------------------------------------------------------------------.
| demo.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrhudson@bigfoot.com>		      	      |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <menu.h>
 
char _prog_name[] = "Menu Thing C-demo";

void (*_consetup)() = consetup_title;

char *_endmsg="\n\nEnd of C-demo";

long _stack = 16000;           /* MENU_REXT likes _lots_ of stack */

main()
{
   int i,noptions,option;

   static char *menu_options[] =
   {
      {"File Select"},
      {"Directory Select"},
      {"Extension Select"},
      {"Item Select"},
      {"Report Error"},
      {"File Error"},
      {"Read String"},
      {"List Selection"},
      {"View File"},
      {"Button"},
      {"Do and Report"},
      {"Character Select"},
      {"Default Settings"},
      {"Extended Button"}
   };

   static short status[sizeof(menu_options)/sizeof(char *)]={WSI_AVBL};
   short done=0;

   noptions = sizeof(menu_options)/sizeof(char *);

   while(!done)
   {
      option = ListSelect("QMenu",menu_options,noptions,
                          4,0,1,0,0,-1,-1,NULL);

      switch (option) {
      case -2 :
      case -1 : done=1; break;
      case 0 :
      {
         char p[72]="win1_";
         char buf[72]="win1_boot";
         char ext[4]="";

         /* p & buf must be big enough for long file names */

         int iret;
       
         iret = FileSelect("Menu File Select Test",p,ext,buf,0,0,0,2,2);

         printf("FSEL:<%d>p=<%s>\nFSEL:buf=<%s>\n",iret,p,buf);

         if (iret>=0)
         {
            ViewFile(buf,NULL,NULL,0,-1,-1);
            printf("VIEW:\n");
         }
         break;
      }
      case 1 :
      {
         int iret;
         char buf[40]="";

         iret = DirSelect("Directory Select",buf,0,0,0,-1,-1);
         printf("DSEL:<%d>%s\n",iret,buf); scanf("");
         break;
      }
      case 2 :
      {
         char buf[8]="";
         int iret;

         iret = ExtSelect(buf,0,0,-1);
         printf("XSEL:<%d>%s\n",iret,buf);
         scanf("");
         break;
      }
      case 3 :
      {
         printf("ITSL:<%d>\n",ItemSelect("Item Select",
                "Pick one of\nthree items.",
                "Centre","Right","Left",0,0,-1));
         scanf("");
         break;
      }
      case 4 :
         ReportError(ERR_OM,-1,-1,-1);
         break;
      case 5 :
      {
         printf("FERR:%d\n",FileError(ERR_NF,1,-1,-1,-1));
         scanf("");
         break;
      }
      case 6 :
      {
         char buf[40];
         int iret;

         *buf=0;
         iret = ReadString("Your Name ?","Please Enter Below","Joe Bloggs",0,buf,0,0,-1);
         printf("RSTR:%s\n",buf);
         scanf("");
         break;
      }
      case 7 :
      {
         int i,nitems,iret;
         static char *items[] =
         {
            {"Item 0"},
            {"Item 1"},
            {"Item 2"},
            {"Item 3"},
            {"Item 4"},
            {"Item 5"},
            {"Item 6"},
            {"Item 7"},
            {"Item 8"},
            {"Item 9"},
         };
         static short sts[sizeof(items)/sizeof(char *)]={WSI_AVBL};
         nitems = sizeof(items)/sizeof(char *);

         iret = ListSelect("Multi-Choice",items,nitems,
                           4,5,2,0,0,-1,-1,sts);
         printf("LIST:");
         for(i=0;i<nitems;i++)
            if (sts[i]==WSI_SLCT)
            {
               sts[i]=WSI_UNAV;
               printf("<%d>",i);
            }
         printf("\n");
         scanf("");
         break;
      }
      case 8 :
      {
         ViewFile("win1_boot",NULL,NULL,0,-1,-1);
         printf("VIEW:\n");
         scanf("");
         break;
      }
      case 9 : Button("CDEMO",-1,-1,-1); break;
      case 10 :
      {
         printf("DORP:\n");
         scanf("");
         break;
      }
      case 11 : 
      {
         char buf[2];
         int i;

         *buf=0;
         i=CharSel("CHSL Test",0x0000001e,buf,NULL,-1,-1,2,2);
         printf("CHSL:<%d><%c>\n",i,*buf);
         scanf("");
         break;
      }
      case 12 :
      {
         char buf[40];

         printf("INFO:%s\n",MenuInfo(32,buf));
         scanf("");
         break;
      }
      case 13 :
      {
         printf("XBTN:\n");
         scanf("");
         break;
      }
      default: break;
      }
   }
}
