/*--------------------------------------------------------------------.
| doreport.c                                                          |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"


int DoReport (char *name, char *desc, int chars, int xpos, int ypos, 
          int mainc, int mictl, MENU_CB_t func)
{
    MENUDORP dp;
    QD_TEXT (39) namestr;
    QD_TEXT (39) descstr;
    AFUNC_t f;
    ACTION_t a;

    dp.mennm.info = 0;

    if(name)
    {
        dp.mennm.attr = THP_CALL | THP_STR;
        MOVEINS (&namestr, name);
        dp.mennm.ptr = &namestr;
    }
    else
    {
        dp.mennm.attr = 0;
        dp.mennm.ptr = NULL;
    }
    dp.actds.info = 0;
    if(desc)
    {
        dp.actds.attr = THP_CALL | THP_STR;
        MOVEINS (&descstr, desc);
        dp.actds.ptr = &descstr;
    }
    else
    {
        dp.actds.attr = 0;
        dp.actds.ptr = NULL;
    }

    dp.xpos = xpos;
    dp.ypos = ypos;
    dp.mainc = mainc;
    dp.mictl = mictl;
    dp.chars = chars;

    a.jsr = JSR;
    a.interface = _menu_act; 
    a.function = &f;
    f.func = func;
    if(chars > 0)
    {
        f.param = alloca(chars+2);
    }
    else
    {
        f.param = NULL;
    }
    dp.pact = &a;

    return(_use_qmenu(DORP, &dp));
}
