/*--------------------------------------------------------------------.
| putscrap.c                                                          |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"

int PutScrap (unsigned char dtyp, void *dataptr,
              unsigned long buflen, SCRAP_CB_t func)
{
    SCRAPPUT sp;
    SFUNC_t f;
    ACTION_t a;

    sp.opt = THP_OPT | THP_UBYT;
    sp.pack = 0;
    sp.dtyp = dtyp;
    sp.strg.attr = THP_CALL | THP_STR | THP_ULNG;
    sp.strg.info = 0;
    sp.strg.ptr = dataptr;
    sp.flln = buflen;
    if(func)
    {
        a.jsr = JSR;
        a.interface = _scrap_act;
        a.function = &f;
        f.func = func;
        f.param = &sp.strg.ptr;
        sp.uccd = &a;
    }
    else
        sp.uccd = NULL;

    return(_use_scrap(PUT, &sp));
}
