/*--------------------------------------------------------------------.
| readstring.c                                                        |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"

int ReadString (char *name, char *prmpt, char *dflt, int chars, char *buf,
                int xpos, int ypos, int mainc)
{
    int iret;

    QD_TEXT (39) namestr;
    QD_TEXT (39) dfltstr;
    QD_TEXT (39) prmptstr;
    QD_TEXT (39) rsltstr;

    MENURSTR rs;

    rs.chars = chars;
    rs.xpos = xpos;
    rs.ypos = ypos;
    rs.mainc = mainc;

    rs.mennm.info = 0;
    if (name)
    {
        rs.mennm.attr = THP_CALL | THP_STR;
        MOVEINS (&namestr, name);
        rs.mennm.ptr = &namestr;
    }
    else
    {
        rs.mennm.attr = 0;
        rs.mennm.ptr = NULL;
    }
    
    rs.defnm.info = 0;
    if (dflt)
    {
        rs.defnm.attr = THP_CALL | THP_STR;
        MOVEINS (&dfltstr, dflt);
        rs.defnm.ptr = &dfltstr;
    }
    else
    {
        rs.defnm.attr = 0;
        rs.defnm.ptr = NULL;
    }
    
    rs.prmpt.info = 0;
    if (prmpt)
    {
        rs.prmpt.attr = THP_CALL | THP_STR;
        MOVEINS (&prmptstr, prmpt);
        rs.prmpt.ptr = &prmptstr;
    }
    else
    {
        rs.prmpt.attr = 0;        
        rs.prmpt.ptr = NULL;
    }
    
    rs.fname.attr = THP_RET | THP_STR;
    rs.fname.info = 0;
    rs.fname.ptr = &rsltstr;
    rsltstr.len = 0;

    iret = _use_qmenu(RSTR, &rs);
    if (iret >= 0)
    {
        RESTORES (buf, &rsltstr);
    }
    return iret;
}
